/**
 * Copyright(C) 2005 NSP. All rights reserved.
 * sse2 ΉȂ -msse2 č(3{炢Ȃ)
 * sse  ΉȂ -msse  float̃[`
 * łȂĂ int ̃[`͑ł傤(ő)
 *
 * Ƃ[Cm[gob
 * d PentiumM 1.1G (Banias) + 512M(PC2100), VGA
 * ŃmN`悠 43fps, `Ȃ 90fps (boundary, int)
 * ŃJ[`悠 20fps, `Ȃ 60fps (boundary, int)
 *
 * ŃmN`悠 44fps, `Ȃ 110fps (boundary, int, pre)
 * ŃJ[`悠 20fps, `Ȃ 60fps (boundary, int, pre)
 *
 * ŃmN`悠 49fps, `Ȃ 128fps (boundary, int, pre, unroll)
 * ŃJ[`悠 21fps, `Ȃ 62fps (boundary, int, pre, unroll)
 *
 * ŃmN`悠 52fps, `Ȃ 160fps (DC block)
 * ŃJ[`悠 21fps, `Ȃ 70fps (DC block)
 *
 * ŃmN`悠 52fps, `Ȃ 190fps (DC block, unroll)
 * ŃJ[`悠 21fps, `Ȃ 70fps (DC block, unroll)
 *
 * ƂŁCWindow 𓮂Ȃƕ`ʒuȂȂ͉̂̂낤H
 *
 * g++ ImageRotator.cpp -o ImageRotator `sdl-config --cflags --libs` -lglut32 -lopengl32 -lglu32 -lpng -mno-cygwin -O3 -lpng12 -lz -msse2 -msse
 *
 * XxȂ邪CJ[łȂ
 * g++ ImageRotator.cpp -o ImageRotatorF `sdl-config --cflags --libs` -lglut32 -lopengl32 -lglu32 -lpng -mno-cygwin -O3 -lpng12 -lz -msse2 -msse -DFULLCOLOR
 *
 */

/***
 * 摜]vO SDL + OpenGL (+libpng)
 * R}hC tJ[ png w肷Ƃǂ
 * [`قǃTCYɐĂ
 * Vvɂ邩CE`FbNɂ邩
 * vZ double, float, int(Œ菬)
 * [vWJ邩
 * ] 32x32 ̃e[uQiKł邩
 *
 * L[
 * 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, x L[ŃASY؂ւ
 * ESC, q L[ŏI
 * u Ńt[XLbv
 * d Ńt[XLbv
 * p ŕ`E`̐؂ւ
 * f Ŕ`掞 pps(fps) \
 *
 * }EXŃhbOƉ摜
 *
 * IvV
 *  ./ImageRotator [-f] [-w XXXxYYY] [pngimage]
 *    -f         : fullscreen
 *    -w XXXxYYY : set windows size to XXXxYYY
 *    pngimage   : load fullcolor png image
 */
#include <iostream>
#include <SDL/SDL.h>
#include <GL/glut.h>
#include <cstdlib>     
#include <cmath>     
#include <png.h>

//#define FULLCOLOR       // fullcolor mode
//#define ALPHA           // use alpha channel?
#define USETEXTURE        // use texture

using namespace std;

const int ImageSizeBits = 10;
const int ImageSize   = 1<<ImageSizeBits;  // 摜TCY 2^n  2^20 炢܂
const int whiteSpace  = 2;
const int statusFieldY= 18;
const int ImageHeight = ImageSize;  // should be equal to ImageSize
const int ImageWidth  = ImageSize;  // should be equal to ImageSize
const int ColorDepth  = 32;
const int millisHistLength = 4;
const int shifts = 12;           // Œ菬̏rbg >= ImageSizeBits;
const int shiftsMulti = 1<<shifts;
const int shifts2 = shifts - ImageSizeBits;
const int shifts2mask = ~(shiftsMulti-1);
int WindowSizeX = ImageSize+whiteSpace*2;
int WindowSizeY = ImageSize+whiteSpace*2+statusFieldY;

int leftTopX = whiteSpace;
int leftTopY = whiteSpace;

int stepsPerDraw = 1;

int fps;                         // fps֌W
int steps;
int totalSteps;
int stepsHist[millisHistLength];
int totalMillis;
int millisHist[millisHistLength];
int sp;
bool painting;
int freqFPSUpdate = 2;
bool fpsDrawFlag;


int boundsl[360][ImageWidth];
int boundsr[360][ImageHeight];

int rotType = 9;
SDL_Surface *screen;

GLuint texName;

#ifdef FULLCOLOR
//typedef GLuint PixelData
#define PixelData GLuint
#else
//typedef GLubyte PixelData
#define PixelData GLubyte
#endif

PixelData *basePixels;
PixelData *basePixelsR;
PixelData *rotatedPixels;


int base;

char *algos[] = { "DC block", "simple", "boundary", "simple(float)", "boundary(float)", "simple(int)", "boundary(int)", "boundary(int, pre)", "boundary(int, unroll)", "boundary(int, pre, unroll)","DC block unroll"};

PixelData *basePixelsExt;
int rotTable1[360][1024];
int rotTable2[360][1024];
const int ImageHeightExt = ImageSize/2*3;  
const int ImageWidthExt  = ImageSize/2*3;  


void genRotTableI(int thi)
{
	int p = 0;
	double th = thi*M_PI/180;
	double sinth = -sin(th);
	double costh = cos(th);
	double cx = (ImageWidth - 1) / 2.;
    double cy = (ImageHeight - 1) / 2.;
	double cxE = (ImageWidthExt - 1) / 2.;
    double cyE = (ImageHeightExt - 1) / 2.;
	int k = 0;
	for(int i = 15; i < ImageHeight; i+=32){
		for(int j = 15; j < ImageWidth; j+=32){
			double x = (i - cx);
			double y = (j - cy);
			double xx = x * costh - y * sinth + cxE;
			double yy = x * sinth + y * costh + cyE;
			rotTable1[thi][k++] = ((int)(xx))*ImageWidthExt + ((int)(yy));
		}
	}
	k = 0;
	for(int i = 0; i < 32; i++){
		for(int j = 0; j < 32;j++){
			double x = (i - 15);
			double y = (j - 15);
			double xx = x * costh - y * sinth;
			double yy = x * sinth + y * costh;
			rotTable2[thi][k++] = ((int)(xx))*ImageWidthExt + ((int)(yy));
		}
	}
}

void genRotTable()
{
	for(int i = 0; i < 360; i++){
		genRotTableI(i);
	}
}

void genBoundsI(double th, int idx)
{
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
    double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const int heightE = height << shifts;
	const int widthE = width << shifts;
	const int mask = ~(shiftsMulti-1);

	int sy = 0;
	int blsy = -1;
	int brsy = -1;

	const bool colmajor = abs(sinth) >= abs(costh);
	for(; sy < height; sy++){
		int xx = yx;
		int xy = yy;
		blsy = -1;
		brsy = -1;
			
		for(int j = 0; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
			} else {
				blsy = j;
				break;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			yx+=-isinth;
			yy+=icosth;
			boundsl[idx][sy] = width;
			boundsr[idx][sy] = width;
			continue;
		}
		xx = yx+(width - 1)*icosth;
		xy = yy+(width - 1)*isinth;
		for(int j = width - 1; j >=blsy; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

			} else {
				brsy = j;
				break;
			}
			xx-=icosth;
			xy-=isinth;
		}
		break;
	}
	int pblsy = blsy;
	int pbrsy = brsy;
	for(; sy < height; sy++){
		blsy = -1;
		brsy = -1;
			
		int xx = yx+pblsy*icosth;
		int xy = yy+pblsy*isinth;
		for(int j = pblsy; j >= 0; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				blsy = j;
			}
			xx-=icosth;
			xy-=isinth;
		}
		if(blsy==-1){
			xx = yx+(pblsy+1)*icosth;
			xy = yy+(pblsy+1)*isinth;
			for(int j = pblsy + 1; j < width; j++){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					blsy = j;
					break;
				}
				xx+=icosth;
				xy+=isinth;
			}
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			break;
		}
		xx = yx+(pbrsy)*icosth;
		xy = yy+(pbrsy)*isinth;
		for(int j = pbrsy; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				brsy = j;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(brsy==-1){
			xx = yx+(pbrsy-1)*icosth;
			xy = yy+(pbrsy-1)*isinth;
			for(int j = pbrsy - 1; j >= blsy; j--){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					brsy = j;
					break;
				}
				xx-=icosth;
				xy-=isinth;
			}
		}
		for(int j = 0; j < blsy; j++){
			rotatedPixels[p++] = 00;
		}
		xx = yx+(blsy)*icosth;
		xy = yy+(blsy)*isinth;
		if(colmajor){     // col major
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))];
				xx+=icosth;
				xy+=isinth;
			}
		} else {
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)];
				xx+=icosth;
				xy+=isinth;
			}
		}
		for(int j = brsy; j < width; j++){
			rotatedPixels[p++] = 0;
		}
		pblsy = blsy;
		pbrsy = brsy;
		yx+=-isinth;
		yy+=icosth;
		boundsl[idx][sy] = blsy;
		boundsr[idx][sy] = brsy;
	}
	sy++;
	for(; sy < height; sy++){
		boundsl[idx][sy] = width;
		boundsr[idx][sy] = width;
	}


}

void genBounds()
{
	for(int i = 0; i < 360; i++){
		//boundsl[i][0] = -1;          // ƂŕKvɐ
		genBoundsI(i*M_PI/180, i); // 
	}
}


// Vvɖ񌳉摜̃sNZRs[ł邩mFD
// if ̂Œx
// ł͂₢
void rotate1(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
	double cy = (height - 1) / 2.;
	double yx = -costh*cx + cy*sinth + cx;
	double yy = -sinth*cx - cy*costh + cy;
	if(abs(sinth) >= abs(costh)){     // col major
		for(int i = 0; i < height; i++){
			double xx = yx;
			double xy = yy;
			
			for(int j = 0; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixelsR[ix*height+iy];
				}
				p++;
				xx+=costh;
				xy+=sinth;
			}
			yx+=-sinth;
			yy+=costh;
		}
	} else {                                 // row major
		for(int i = 0; i < height; i++){
			double xx = yx;
			double xy = yy;
			for(int j = 0; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixels[ix+iy*width];
				}
				p++;
				xx+=costh;
				xy+=sinth;
			}
			yx+=-sinth;
			yy+=costh;
		}
	}
}
// Vvɖ񌳉摜̃sNZRs[ł邩mFD
// if ̂Œx
// ł͂₢
// float
void rotate3(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	float sinth = (float)sin(th);
	float costh = (float)cos(th);
	float cx = (width - 1) / 2.;
	float cy = (height - 1) / 2.;
	float yx = -costh*cx + cy*sinth + cx;
	float yy = -sinth*cx - cy*costh + cy;
	if(abs(sinth) >= abs(costh)){     // col major
		for(int i = 0; i < height; i++){
			float xx = yx;
			float xy = yy;
			
			for(int j = 0; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixelsR[ix*height+iy];
				}
				p++;
				xx+=costh;
				xy+=sinth;
			}
			yx+=-sinth;
			yy+=costh;
		}
	} else {                                 // row major
		for(int i = 0; i < height; i++){
			float xx = yx;
			float xy = yy;
			for(int j = 0; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixels[ix+iy*width];
				}
				p++;
				xx+=costh;
				xy+=sinth;
			}
			yx+=-sinth;
			yy+=costh;
		}
	}
}

/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * [vt[W(ӖȂH)
 * ͖Ă(1.5{Ȃ)
 */
void rotate2(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
	double cy = (height - 1) / 2.;
	int sy = 0;
	int blsy = -1;
	int brsy = -1;
	double yx = -costh*cx + cy*sinth + cx;
	double yy = -sinth*cx - cy*costh + cy;

	const bool colmajor = abs(sinth) >= abs(costh);
	for(; sy < height; sy++){
		double xx = yx;
		double xy = yy;
		blsy = -1;
		brsy = -1;
			
		for(int j = 0; j < width; j++){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
			} else {
				blsy = j;
				break;
			}
			xx+=costh;
			xy+=sinth;
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			yx+=-sinth;
			yy+=costh;
			continue;
		}
		xx = yx+(width - 1)*costh;
		xy = yy+(width - 1)*sinth;
		for(int j = width - 1; j >=blsy; j--){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){

			} else {
				brsy = j;
				break;
			}
			xx-=costh;
			xy-=sinth;
		}
		break;
	}
	int pblsy = blsy;
	int pbrsy = brsy;
	for(; sy < height; sy++){
		blsy = -1;
		brsy = -1;
			
		double xx = yx+pblsy*costh;
		double xy = yy+pblsy*sinth;
		for(int j = pblsy; j >= 0; j--){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
				break;
			} else {
				blsy = j;
			}
			xx-=costh;
			xy-=sinth;
		}
		if(blsy==-1){
			xx = yx+(pblsy+1)*costh;
			xy = yy+(pblsy+1)*sinth;
			for(int j = pblsy + 1; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){

				} else {
					blsy = j;
					break;
				}
				xx+=costh;
				xy+=sinth;
			}
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			break;
		}
		xx = yx+(pbrsy)*costh;
		xy = yy+(pbrsy)*sinth;
		for(int j = pbrsy; j < width; j++){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
				break;
			} else {
				brsy = j;
			}
			xx+=costh;
			xy+=sinth;
		}
		if(brsy==-1){
			xx = yx+(pbrsy-1)*costh;
			xy = yy+(pbrsy-1)*sinth;
			for(int j = pbrsy - 1; j >= blsy; j--){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){

				} else {
					brsy = j;
					break;
				}
				xx-=costh;
				xy-=sinth;
			}
		}
		for(int j = 0; j < blsy; j++){
			rotatedPixels[p++] = 00;
		}
		xx = yx+(blsy)*costh;
		xy = yy+(blsy)*sinth;
		if(colmajor){     // col major
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++]=basePixelsR[(int)(xx)*height+(int)(xy)];
				xx+=costh;
				xy+=sinth;
			}
		} else {
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixels[(int)(xx)+(int)(xy)*width];
				xx+=costh;
				xy+=sinth;
			}
		}
		for(int j = brsy; j < width; j++){
			rotatedPixels[p++] = 0;
		}
		pblsy = blsy;
		pbrsy = brsy;
		yx+=-sinth;
		yy+=costh;
	}
	memset(rotatedPixels+p, 0, (width*height-p)*sizeof(PixelData));
}
/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * [vt[W(ӖȂH)
 * ͖Ă(1.5{Ȃ)
 * float o[W
 */
void rotate4(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	float sinth = (float)sin(th);
	float costh = (float)cos(th);
	float cx = (width - 1) / 2.;
	float cy = (height - 1) / 2.;
	int sy = 0;
	int blsy = -1;
	int brsy = -1;
	float yx = -costh*cx + cy*sinth + cx;
	float yy = -sinth*cx - cy*costh + cy;

	const bool colmajor = abs(sinth) >= abs(costh);
	for(; sy < height; sy++){
		float xx = yx;
		float xy = yy;
		blsy = -1;
		brsy = -1;
			
		for(int j = 0; j < width; j++){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
			} else {
				blsy = j;
				break;
			}
			xx+=costh;
			xy+=sinth;
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			yx+=-sinth;
			yy+=costh;
			continue;
		}
		xx = yx+(width - 1)*costh;
		xy = yy+(width - 1)*sinth;
		for(int j = width - 1; j >=blsy; j--){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){

			} else {
				brsy = j;
				break;
			}
			xx-=costh;
			xy-=sinth;
		}
		break;
	}
	int pblsy = blsy;
	int pbrsy = brsy;
	for(; sy < height; sy++){
		blsy = -1;
		brsy = -1;
			
		float xx = yx+pblsy*costh;
		float xy = yy+pblsy*sinth;
		for(int j = pblsy; j >= 0; j--){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
				break;
			} else {
				blsy = j;
			}
			xx-=costh;
			xy-=sinth;
		}
		if(blsy==-1){
			xx = yx+(pblsy+1)*costh;
			xy = yy+(pblsy+1)*sinth;
			for(int j = pblsy + 1; j < width; j++){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){

				} else {
					blsy = j;
					break;
				}
				xx+=costh;
				xy+=sinth;
			}
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			break;
		}
		xx = yx+(pbrsy)*costh;
		xy = yy+(pbrsy)*sinth;
		for(int j = pbrsy; j < width; j++){
			int ix = (int)(xx);
			int iy = (int)(xy);
			if(ix < 0 || ix >= width || iy < 0 || iy>=height){
				break;
			} else {
				brsy = j;
			}
			xx+=costh;
			xy+=sinth;
		}
		if(brsy==-1){
			xx = yx+(pbrsy-1)*costh;
			xy = yy+(pbrsy-1)*sinth;
			for(int j = pbrsy - 1; j >= blsy; j--){
				int ix = (int)(xx);
				int iy = (int)(xy);
				if(ix < 0 || ix >= width || iy < 0 || iy>=height){

				} else {
					brsy = j;
					break;
				}
				xx-=costh;
				xy-=sinth;
			}
		}
		for(int j = 0; j < blsy; j++){
			rotatedPixels[p++] = 00;
		}
		xx = yx+(blsy)*costh;
		xy = yy+(blsy)*sinth;
		if(colmajor){     // col major
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++]=basePixelsR[(int)(xx)*height+(int)(xy)];
				xx+=costh;
				xy+=sinth;
			}
		} else {
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixels[(int)(xx)+(int)(xy)*width];
				xx+=costh;
				xy+=sinth;
			}
		}
		for(int j = brsy; j < width; j++){
			rotatedPixels[p++] = 0;
		}
		pblsy = blsy;
		pbrsy = brsy;
		yx+=-sinth;
		yy+=costh;
	}
	memset(rotatedPixels+p, 0, (width*height-p)*sizeof(PixelData));
}
// Vvɖ񌳉摜̃sNZRs[ł邩mFD
// if ̂Œx
// ł͂₢
// int
void rotate5(double th)
{
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
    double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const int heightE = height << shifts;
	const int widthE = width << shifts;
	const int mask = ~(shiftsMulti-1);
	if(abs(sinth) >= abs(costh)){     // col major
		for(int i = 0; i < height; i++){
			int xx = yx;
			int xy = yy;
			
			for(int j = 0; j < width; j++){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixelsR[((xx>>shifts)*height)+(xy>>shifts)];
				}
				p++;
				xx+=icosth;
				xy+=isinth;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	} else {                                 // row major
		for(int i = 0; i < height; i++){
			int xx = yx;
			int xy = yy;
			
			for(int j = 0; j < width; j++){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
					rotatedPixels[p] = 0;
				} else {
					rotatedPixels[p] = basePixels[((xx>>shifts))+((xy>>shifts)*width)];
				}
				p++;
				xx+=icosth;
				xy+=isinth;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	}
}
/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * [vt[W(ӖȂH)
 * ͖Ă(1.5{Ȃ)
 * int
 */
void rotate6(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
    double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const int heightE = height << shifts;
	const int widthE = width << shifts;
	const int mask = ~(shiftsMulti-1);

	int sy = 0;
	int blsy = -1;
	int brsy = -1;

	const bool colmajor = abs(sinth) >= abs(costh);
	for(; sy < height; sy++){
		int xx = yx;
		int xy = yy;
		blsy = -1;
		brsy = -1;
			
		for(int j = 0; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
			} else {
				blsy = j;
				break;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			yx+=-isinth;
			yy+=icosth;
			continue;
		}
		xx = yx+(width - 1)*icosth;
		xy = yy+(width - 1)*isinth;
		for(int j = width - 1; j >=blsy; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

			} else {
				brsy = j;
				break;
			}
			xx-=icosth;
			xy-=isinth;
		}
		break;
	}
	int pblsy = blsy;
	int pbrsy = brsy;
	for(; sy < height; sy++){
		blsy = -1;
		brsy = -1;
			
		int xx = yx+pblsy*icosth;
		int xy = yy+pblsy*isinth;
		for(int j = pblsy; j >= 0; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				blsy = j;
			}
			xx-=icosth;
			xy-=isinth;
		}
		if(blsy==-1){
			xx = yx+(pblsy+1)*icosth;
			xy = yy+(pblsy+1)*isinth;
			for(int j = pblsy + 1; j < width; j++){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					blsy = j;
					break;
				}
				xx+=icosth;
				xy+=isinth;
			}
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			break;
		}
		xx = yx+(pbrsy)*icosth;
		xy = yy+(pbrsy)*isinth;
		for(int j = pbrsy; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				brsy = j;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(brsy==-1){
			xx = yx+(pbrsy-1)*icosth;
			xy = yy+(pbrsy-1)*isinth;
			for(int j = pbrsy - 1; j >= blsy; j--){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					brsy = j;
					break;
				}
				xx-=icosth;
				xy-=isinth;
			}
		}
		for(int j = 0; j < blsy; j++){
			rotatedPixels[p++] = 00;
		}
		xx = yx+(blsy)*icosth;
		xy = yy+(blsy)*isinth;
		if(colmajor){     // col major
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))];
				xx+=icosth;
				xy+=isinth;
			}
		} else {
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)];
				xx+=icosth;
				xy+=isinth;
			}
		}
		for(int j = brsy; j < width; j++){
			rotatedPixels[p++] = 0;
		}
		pblsy = blsy;
		pbrsy = brsy;
		yx+=-isinth;
		yy+=icosth;
	}
	memset(rotatedPixels+p, 0, (width*height-p)*sizeof(PixelData));
}

/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * px𐮐ŗ^Ă̂ŋE̒l͍ėpD
 * rbgZ
 * int
 */
void rotate7(const int thi)
{
	const double th = thi * M_PI / 180;
	if(boundsl[thi][0] == -1){
		genBoundsI(th, thi);
	}
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
    double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const bool colmajor = abs(sinth) >= abs(costh);
	if(colmajor){     // col major
		for(int i = 0; i < height; i++){
			int blsy = boundsl[thi][i];
			int brsy = boundsr[thi][i];
			int xx = yx+(blsy)*icosth;
			int xy = yy+(blsy)*isinth;
			for(int j = 0; j < blsy; j++){
				rotatedPixels[p++] = 0;
			}
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)];
				xx+=icosth;
				xy+=isinth;
			}
			for(int j = brsy; j < width; j++){
				rotatedPixels[p++] = 0;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	} else {
		for(int i = 0; i < height; i++){
			int blsy = boundsl[thi][i];
			int brsy = boundsr[thi][i];
			int xx = yx+(blsy)*icosth;
			int xy = yy+(blsy)*isinth;
			for(int j = 0; j < blsy; j++){
				rotatedPixels[p++] = 0;
			}
			for(int j = blsy; j < brsy; j++){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)];
				xx+=icosth;
				xy+=isinth;
			}
			for(int j = brsy; j < width; j++){
				rotatedPixels[p++] = 0;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	}
}
/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * [vt[W(ӖȂH)
 * ͖Ă(1.5{Ȃ)
 * int
 * loop unrolling (Ȃ)
 */
void rotate8(double th){
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
	double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const int heightE = height << shifts;
	const int widthE = width << shifts;
	const int mask = ~(shiftsMulti-1);

	int sy = 0;
	int blsy = -1;
	int brsy = -1;

	const bool colmajor = abs(sinth) >= abs(costh);
	for(; sy < height; sy++){
		int xx = yx;
		int xy = yy;
		blsy = -1;
		brsy = -1;
			
		for(int j = 0; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
			} else {
				blsy = j;
				break;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			yx+=-isinth;
			yy+=icosth;
			continue;
		}
		xx = yx+(width - 1)*icosth;
		xy = yy+(width - 1)*isinth;
		for(int j = width - 1; j >=blsy; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

			} else {
				brsy = j;
				break;
			}
			xx-=icosth;
			xy-=isinth;
		}
		break;
	}
	int pblsy = blsy;
	int pbrsy = brsy;
	for(; sy < height; sy++){
		blsy = -1;
		brsy = -1;
			
		int xx = yx+pblsy*icosth;
		int xy = yy+pblsy*isinth;
		for(int j = pblsy; j >= 0; j--){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				blsy = j;
			}
			xx-=icosth;
			xy-=isinth;
		}
		if(blsy==-1){
			xx = yx+(pblsy+1)*icosth;
			xy = yy+(pblsy+1)*isinth;
			for(int j = pblsy + 1; j < width; j++){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					blsy = j;
					break;
				}
				xx+=icosth;
				xy+=isinth;
			}
		}
		if(blsy==-1){
			memset(rotatedPixels+p, 0, width*sizeof(PixelData));
			p+=width;
			break;
		}
		xx = yx+(pbrsy)*icosth;
		xy = yy+(pbrsy)*isinth;
		for(int j = pbrsy; j < width; j++){
			if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){
				break;
			} else {
				brsy = j;
			}
			xx+=icosth;
			xy+=isinth;
		}
		if(brsy==-1){
			xx = yx+(pbrsy-1)*icosth;
			xy = yy+(pbrsy-1)*isinth;
			for(int j = pbrsy - 1; j >= blsy; j--){
				if(xx < 0 || xx >= widthE || xy < 0 || xy>=heightE){

				} else {
					brsy = j;
					break;
				}
				xx-=icosth;
				xy-=isinth;
			}
		}
		for(int j = 0; j < blsy; j++){
			rotatedPixels[p++] = 00;
		}
		xx = yx+(blsy)*icosth;
		xy = yy+(blsy)*isinth;
		if(colmajor){     // col major
			int ll = brsy - blsy;
			for(; (ll &0xf) !=0; ll--){
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
			}
			for(; ll > 0; ll-=16){
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xx>>shifts)*height)+((xy>>shifts))]; xx+=icosth; xy+=isinth;
			}
		} else {
			int ll = brsy - blsy;
			for(; (ll &0xf) !=0; ll--){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
			}
			for(; ll > 0; ll-=16){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy>>shifts)*width)]; xx+=icosth; xy+=isinth;
			}
		}
		for(int j = brsy; j < width; j++){
			rotatedPixels[p++] = 0;
		}
		pblsy = blsy;
		pbrsy = brsy;
		yx+=-isinth;
		yy+=icosth;
	}
	memset(rotatedPixels+p, 0, (width*height-p)*sizeof(PixelData));
}

/***
 * esɑ΂ė\ߌ摜Rs[ł͈͂vZĂ
 * px𐮐ŗ^Ă̂ŋE̒l͍ėpD
 * rbgZ
 * int
 * loop unrolling (Ȃ)
 */
void rotate9(const int thi)
{
	const double th = thi * M_PI / 180;
	if(boundsl[thi][0] == -1){
		genBoundsI(th, thi);
	}
	const int height = ImageHeight;
	const int width  = ImageWidth;
	int p = 0;
	double sinth = sin(th);
	double costh = cos(th);
	double cx = (width - 1) / 2.;
    double cy = (height - 1) / 2.;
	int yx = (int)((-costh*cx + cy*sinth + cx)*shiftsMulti);
	int yy = (int)((-sinth*cx - cy*costh + cy)*shiftsMulti);
	const int icosth = (int)(costh*shiftsMulti);
	const int isinth = (int)(sinth*shiftsMulti);
	const bool colmajor = abs(sinth) >= abs(costh);
	if(colmajor){     // col major
		for(int i = 0; i < height; i++){
			int blsy = boundsl[thi][i];
			int brsy = boundsr[thi][i];
			int xx = yx+(blsy)*icosth;
			int xy = yy+(blsy)*isinth;
			for(int j = 0; j < blsy; j++){
				rotatedPixels[p++] = 0;
			}
			int ll = brsy - blsy;
			for(; (ll &0xf) !=0; ll--){
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)];
				xx+=icosth;
				xy+=isinth;
			}
			for(; ll > 0; ll-=16){
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixelsR[((xy>>shifts))+((xx&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
			}
			for(int j = brsy; j < width; j++){
				rotatedPixels[p++] = 0;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	} else {
		for(int i = 0; i < height; i++){
			int blsy = boundsl[thi][i];
			int brsy = boundsr[thi][i];
			int xx = yx+(blsy)*icosth;
			int xy = yy+(blsy)*isinth;
			for(int j = 0; j < blsy; j++){
				rotatedPixels[p++] = 0;
			}
			int ll = brsy - blsy;
			for(; (ll &0xf) !=0; ll--){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)];
				xx+=icosth;
				xy+=isinth;
			}
			for(; ll > 0; ll-=16){
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
				rotatedPixels[p++] = basePixels[((xx>>shifts))+((xy&shifts2mask)>>shifts2)]; xx+=icosth; xy+=isinth;
			}
			for(int j = brsy; j < width; j++){
				rotatedPixels[p++] = 0;
			}
			yx+=-isinth;
			yy+=icosth;
		}
	}
}

/**
 * blocking DC ōW 32x32 ŐɌvZĂQiKD
 * ǂĂȂc@͂₢񂾂
 */
void rotate0(const int thi)
{
	int *q = rotTable1[thi];
	for(int i = 0; i < 32; i++){
		for(int j = 0; j < 32; j++){
			int b = *q++;
			int *r = rotTable2[thi];
			PixelData *p = &rotatedPixels[i*32*ImageWidth+j*32];
			for(int k = 0; k < 32; k++){
				for(int l = 0; l < 32; l++){
					*p++= basePixelsExt[*r+++b];
				}
				p+=(ImageWidth-32);
			}
		}
	}
}
/**
 * blocking DC ōW 32x32 ŐɌvZĂQiKD
 * ǂĂȂc@͂₢񂾂
 * unroll
 */
void rotateX(const int thi)
{
	int *q = rotTable1[thi];
	for(int i = 0; i < 32; i++){
		for(int j = 0; j < 32; j++){
			int b = *q++;
			int *r = rotTable2[thi];
			PixelData *p = &rotatedPixels[i*32*ImageWidth+j*32];
			for(int k = 0; k < 32; k++){
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				*p++= basePixelsExt[*r+++b];
				p+=(ImageWidth-32);
			}
		}
	}
}

void rotate()
{
	static double theta = 0;
	static int thetai = 0;
	thetai++;
	if(thetai >= 360) thetai = 0;
	theta=thetai*M_PI/180.;
	//theta = M_PI/4;
	
	switch(rotType){
	case 1:	rotate1(theta);
		break;
	case 2:	rotate2(theta);
		break;
	case 3:	rotate3(theta);
		break;
	case 4:	rotate4(theta);
		break;
	case 5:	rotate5(theta);
		break;
	case 6:	rotate6(theta);
		break;
	case 7:	rotate7(thetai);
		break;
	case 8:	rotate8(theta);
		break;
	case 9:	rotate9(thetai);
		break;
	case 0:	rotate0(thetai);
		break;
	case 10: rotateX(thetai);
		break;
	}
}

// full color PNG ̃obt@ɂĕԂ
int readPNG(const char *fname, unsigned char**buf, int *iHeight, int *iWidth, bool *bAlpha, int *iRowbytes)
{
	const int number = 8;
	unsigned char header[number];
	FILE *fp = fopen(fname, "rb");
	if (!fp) return -1;
	fread(header, 1, number, fp);
	bool is_png = !png_sig_cmp(header, 0, number);   // Signature check
	if (!is_png) return -1;
	png_structp png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if (!png_ptr) return -1;

	png_infop info_ptr = png_create_info_struct(png_ptr);
	if (!info_ptr){
		png_destroy_read_struct(&png_ptr,
								(png_infopp)NULL, (png_infopp)NULL);
		return -1;
	}

	png_infop end_info = png_create_info_struct(png_ptr);
	if (!end_info){
		png_destroy_read_struct(&png_ptr, &info_ptr,
								(png_infopp)NULL);
		return -1;
	}	

	png_init_io(png_ptr, fp);                 // init
	png_set_sig_bytes(png_ptr, number);       // inform libpng read-bytes
	png_read_info(png_ptr, info_ptr);         // get info	

	png_uint_32 width, height;
	int bit_depth, color_type, interlace_type;
	int compression_type, filter_method;
	png_get_IHDR(png_ptr, info_ptr, &width, &height, &bit_depth, &color_type, &interlace_type, &compression_type, &filter_method);
	int channels = png_get_channels(png_ptr, info_ptr);
	int rowbytes = png_get_rowbytes(png_ptr, info_ptr);
	switch(color_type){
	case PNG_COLOR_TYPE_RGB:             // RGB only
	case PNG_COLOR_TYPE_RGB_ALPHA:
		break;
	case PNG_COLOR_TYPE_GRAY:
	case PNG_COLOR_TYPE_PALETTE:
	case PNG_COLOR_MASK_PALETTE:
		//	case PNG_COLOR_MASK_COLOR:
	case PNG_COLOR_MASK_ALPHA:
		return -1;
	}
	if(bit_depth!=8) return -1;

	*buf = new unsigned char[rowbytes*height];
	unsigned char **rows = new unsigned char*[height];
	for(int i = 0; i < height; i++){
		rows[i] = &(*buf)[i*rowbytes];
	}
	png_read_image(png_ptr, rows);
	png_read_end(png_ptr, end_info);
	png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
	*iHeight = height;
	*iWidth = width;
	*bAlpha = color_type == PNG_COLOR_TYPE_RGB_ALPHA;
	*iRowbytes = rowbytes;
	delete rows;
	return 0;
}

void font_init()
{
	base = glGenLists(128);
	for(int i=0;i<128;i++){
		glNewList(base+i, GL_COMPILE);
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, i);
		glEndList();
	}
	glListBase(base);
}

void drawString(const char *out, float r=1.0f, float g=1.0f, float b=1.0f)
{
	//glPushAttrib(GL_ALL_ATTRIB_BITS);
	glColor3f(r, g, b);
	glRasterPos2i(whiteSpace/2, WindowSizeY-statusFieldY+5);
	glCallLists( strlen(out) , GL_BYTE, out);
	//glPopAttrib();
	SDL_WM_SetCaption(out, NULL);
}

void init(const char *fname = NULL)
{
	basePixels = new PixelData[ImageHeight * ImageWidth];
	basePixelsR = new PixelData[ImageHeight * ImageWidth];
	rotatedPixels = new PixelData[ImageHeight * ImageWidth];

	PixelData *p = basePixels;
	unsigned char *buf;
	int height, width, rowbytes;
	bool alpha;
	if(fname!=NULL && !readPNG(fname, &buf, &height, &width, &alpha, &rowbytes)){
		if(!alpha){
			for(int i = 0 ; i < ImageHeight ; i++) {
				if(i < height){
					for(int j = 0 ; j < ImageWidth ; j++) {
						if(j < width){
							int b = buf[rowbytes*(height-i-1)+j*3];
							int g = buf[rowbytes*(height-i-1)+j*3+1];
							int r = buf[rowbytes*(height-i-1)+j*3+2];
#ifdef FULLCOLOR
							*p++ =  0xff000000 | (r << 16) | (g << 8) | b;
#else
							*p++ =(int)(0.21268*r + 0.7151*g + 0.07217*b);
#endif
						} else {
							*p++ = 0;
						}
					}
				} else {
					for(int j = 0 ; j < ImageWidth ; j++) {
						*p++ = 0;
					}
				}
			}
		} else {
			for(int i = 0 ; i < ImageHeight ; i++) {
				if(i < height){
					for(int j = 0 ; j < ImageWidth ; j++) {
						if(j < width){
							int b = buf[rowbytes*(height-i-1)+j*4];
							int g = buf[rowbytes*(height-i-1)+j*4+1];
							int r = buf[rowbytes*(height-i-1)+j*4+2];
							int a = buf[rowbytes*(height-i-1)+j*4+3];
#ifdef FULLCOLOR
#ifdef ALPHA
							r = r * a / 255;
							g = g * a / 255;
							b = b * a / 255;
							*p++ = 0xff000000 | (r << 16) | (g << 8) | b;
#else
							*p++ = (a<<24) | (r << 16) | (g << 8) | b;
#endif
#else
							*p++ = (int)((0.21268*r + 0.7151*g + 0.07217*b) * a / 255);
#endif
						} else {
							*p++ = 0;
						}
					}
				} else {
					for(int j = 0 ; j < ImageWidth ; j++) {
						*p++ = 0;
					}
				}
			}
		}
		delete [] buf;
	} else {
#ifdef FULLCOLOR
		// ftHg
		for(int i = 0 ; i < ImageHeight ; i++) {
			int r = (i * 0xFF) / ImageHeight;
			for(int j = 0 ; j < ImageWidth ; j++) {
				int y = (i^j)&0xff;
				int ry = r * y/0xff;
				int gy = (( j * 0xFF ) / ImageWidth) * y/0xff;
				int by = (~r&0xff) * y/0xff;
				*p++ = 0xff000000 | ry << 16 | gy << 8| by;
			}
		}
#else
		for(int i = 0 ; i < ImageHeight ; i++) {
			for(int j = 0 ; j < ImageWidth ; j++) {
				*p++ = (i^j)&0xff;          // II
				//*p++ = 0x80 | (i*j)&0x7f;
			}
		}
#endif
	}


	p=basePixels;
	for(int i = 0 ; i < ImageHeight ; i++) {
		for(int j = 0 ; j < ImageWidth ; j++) {
			basePixelsR[i+j*ImageHeight] = *p++;
		}
	}
	memcpy(rotatedPixels, basePixels, ImageHeight * ImageWidth * sizeof(PixelData));
	glViewport(0,0, WindowSizeX, WindowSizeY);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity(); 
	glOrtho(0.0, (GLdouble) WindowSizeX , 0.0, (GLdouble) WindowSizeY , -1.0, 1.0);


	fps = 0;
	steps = 0;
	totalSteps = 0;
	totalMillis = 0;
	for(int i = 0; i < millisHistLength; i++){
		stepsHist[i] = 0;
		millisHist[i] = 0;
	}
	sp = 0;
	painting = true;
	font_init();
	glEnable(GL_TEXTURE_2D);
	glGenTextures(1 , &texName);
	glBindTexture(GL_TEXTURE_2D , texName);
	genBounds();
	genRotTable();
	basePixelsExt = new PixelData[ImageHeightExt * ImageWidthExt];
	memset(basePixelsExt, 0, ImageHeightExt * ImageWidthExt*sizeof(PixelData));
	p = basePixels;
	int wBias = (ImageWidthExt - ImageWidth) / 2;
	int hBias = (ImageHeightExt - ImageHeight) / 2;
	for(int i = 0; i < ImageHeight; i++){
		for(int j = 0; j < ImageWidth; j++){
			basePixelsExt[(i+hBias)*ImageWidthExt + (j+wBias)] = *p++;
		}
	}
}

void drawImage()
{
	static char str[128]={0};
	static char *s1 = str;

	sprintf(s1, "%d.%d pps %d.%d fps (skip %d) algo-%d(%s)", fps/100, fps%100, (fps/stepsPerDraw)/100, (fps/stepsPerDraw)%100, stepsPerDraw-1, rotType, algos[rotType]);
	if(painting){
		glEnable(GL_TEXTURE_2D);
		glDisable( GL_DEPTH_TEST );
		glDisable( GL_LIGHTING );
		glClear(GL_COLOR_BUFFER_BIT);

#ifdef USETEXTURE
		glBindTexture(GL_TEXTURE_2D , texName);
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);

#ifdef FULLCOLOR
		glTexImage2D(GL_TEXTURE_2D , 0 , GL_RGBA , ImageWidth , ImageHeight, 0 , GL_RGBA, GL_UNSIGNED_BYTE , rotatedPixels);
#else
		glTexImage2D(
					 GL_TEXTURE_2D , 0 , GL_LUMINANCE , ImageWidth , ImageHeight,
					 0 , GL_LUMINANCE, GL_UNSIGNED_BYTE , rotatedPixels
					 );
#endif
		glBegin(GL_POLYGON);
		glTexCoord2f(0 , 0); glVertex2f(leftTopX ,leftTopY);
		glTexCoord2f(0 , 1); glVertex2f(leftTopX , ImageHeight+leftTopY);
		glTexCoord2f(1 , 1); glVertex2f(ImageWidth + leftTopX, ImageHeight+leftTopY);
		glTexCoord2f(1 , 0); glVertex2f(ImageWidth + leftTopX, leftTopY);
		glEnd();
		glDisable( GL_TEXTURE_2D );
#else

		glRasterPos2i(leftTopX, leftTopY);
#ifdef FULLCOLOR
		glDrawPixels(ImageWidth , ImageHeight, GL_RGBA, GL_UNSIGNED_BYTE, rotatedPixels);
#else
		glDrawPixels(ImageWidth , ImageHeight, GL_LUMINANCE, GL_UNSIGNED_BYTE , rotatedPixels);
#endif
#endif


		//glFlush();
		drawString(s1);
		SDL_GL_SwapBuffers();
	} else {
		if(fpsDrawFlag){
			glClear(GL_COLOR_BUFFER_BIT);
			fpsDrawFlag = false;
			drawString(s1);
			SDL_GL_SwapBuffers();
		}
	}
}

int updateScreen()
{
	static int steps = 0;
	static int time = SDL_GetTicks();
	if(steps%stepsPerDraw==0)
		drawImage();
	rotate();
	steps++;

	int t = SDL_GetTicks();
	if(t - time >= 1000 / freqFPSUpdate){
		totalSteps-=stepsHist[sp];
		totalMillis-=millisHist[sp];
		stepsHist[sp] = steps;
		millisHist[sp] = (int)(t - time);
		totalSteps+=stepsHist[sp];
		totalMillis+=millisHist[sp];
		sp = (sp + 1) % millisHistLength;
		steps = 0;
		fps = totalSteps * 100000 / totalMillis; // fps*100ł
		time = t;
	}
}
bool done = false;

int processEvent()
{
	static bool mouseDown = false;
	SDL_Event e;
	if (SDL_PollEvent(&e) != 0){  // event H
		switch(e.type){
		case SDL_QUIT:
			done = true;
			break;
		case SDL_MOUSEMOTION:
			if(mouseDown){
				leftTopX += e.motion.xrel;
				leftTopY -= e.motion.yrel;
			}
			break;
		case SDL_MOUSEBUTTONDOWN:
		case SDL_MOUSEBUTTONUP:
			if(e.button.button==SDL_BUTTON_LEFT){
				mouseDown = e.button.state == SDL_PRESSED;
			}
			break;
		case SDL_KEYDOWN:
			switch(e.key.keysym.sym){
			case SDLK_1:                 // ASYI
				rotType = 1;
				break;
			case SDLK_2:
				rotType = 2;
				break;
			case SDLK_3:
				rotType = 3;
				break;
			case SDLK_4:
				rotType = 4;
				break;
			case SDLK_5:
				rotType = 5;
				break;
			case SDLK_6:
				rotType = 6;
				break;
			case SDLK_7:
				rotType = 7;
				break;
			case SDLK_8:
				rotType = 8;
				break;
			case SDLK_9:
				rotType = 9;
				break;
			case SDLK_0:
				rotType = 0;
				break;
			case SDLK_x:
				rotType = 10;
				break;
			case SDLK_p:                 // `E`tbv
				painting = !painting;
				break;
			case SDLK_u:                // `XLbv
				stepsPerDraw++;
				break;
			case SDLK_d:
				if(stepsPerDraw>1) stepsPerDraw--;
				break;
			case SDLK_f:                 // fps `
				fpsDrawFlag = true;
				break;
			case SDLK_q:
			case SDLK_ESCAPE:
				done = true;
				break;
			}
			break;
		}
	}
}

int main(int argc,char *argv[])
{
	char fname[512];
	int flags = SDL_OPENGL;// | SDL_FULLSCREEN;
	fname[0] = 0;
	while(argc>1){
		if(argv[1][0]=='-'){
			switch(argv[1][1]){
			case 'w':                    // window size (-w 1024x1024)
				{
					if(argc > 2){
						char *p = argv[2];
						char *q = NULL;
						char *r = p;
						while(*p!=0){
							if(*p=='x') {
								q = p+1;
								break;
							}
							p++;
						}
						if(q!=NULL){
							*p = 0;
							WindowSizeX = atoi(r);
							WindowSizeY = atoi(q);
							argv++;
							argc--;
						}
					}
				}
				break;
			case 'f':              // fullscreen              
				flags |= SDL_FULLSCREEN;
				break;
			}
		} else {
			strcpy(fname, argv[1]);// png file (-f fname)
		}
		argc--;
		argv++;
	}
	
	/* SDL */
	
	if(SDL_Init(SDL_INIT_VIDEO)<0){
		cerr << "SDL Initialization failed." << endl; 
		exit(-1);
	}

	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
#ifdef ALPHA
	SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 );
#endif
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 1 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	/* ʍ쐬 */
	screen = SDL_SetVideoMode(WindowSizeX,WindowSizeY,ColorDepth,flags);
	if(screen == NULL){	
		cerr << "Window Creation failed." << endl; 
		SDL_Quit();
		exit(-2);
	}
	if(fname[0]==0) init();
	else            init(fname);
	
	/* C[v */
	do{
		processEvent();
		updateScreen();
		
	} while(!done);
	
	SDL_Quit();
	return 0;
	
}

	
